
#ifndef FIMAGE_H
#define FIMAGE_H

#include "ImageInfo.h"
#include "JDImage.h"
#include <vector>
#include "Kernel.h"

class FImage {
public:
  float *fPixels;
  short fXSize;
  short fYSize;

  FImage (void);
  FImage (short x, short y);
  FImage (ImageInfo info);
  FImage (FImage &fim);

  FImage &operator=(ImageInfo im);
  
  void Init (void);
  void SetSize (short x, short y);
  void getJDImage(JDImage &im);
  
  // Access to individual pixels
  inline float& Pix(short x,short y) {return (fPixels)[x+y*fXSize]; };
  inline float& ClampedPix(short x, short y) {
    if (x<0) x=0;
    if (x>=fXSize) x=fXSize-1;
    if (y<0) y=0;
    if (y>=fYSize) y=fYSize-1;
    return (fPixels)[x+y*fXSize];};

  // Ops
  void blurX(Kernel &kernel);
  void blurY(Kernel &kernel);
  void blur(Kernel &kernel);
};

#endif
