#include "ImageWin.h"
#include <stdio.h>

ImageWin::ImageWin()
{
	renderBGRA=false;
}
  
ImageWin::~ImageWin()
{
}
 
void ImageWin::display()
{
  if (imageinfo.pixels!=NULL)
    {

#ifdef WIN32
	  // The glRasterPos2f call is required on my laptop
	  // When there are two windows. Apparently its not
	  // stored individually per GL context
	  glRasterPos2f(0, height );

	  //printf ("Drawing pixels in ImageWin %p\n",imageinfo.pixels);
	  if (renderBGRA) {
		glDrawPixels(imageinfo.xsize,imageinfo.ysize, GL_BGRA_EXT,
		   GL_UNSIGNED_BYTE, imageinfo.pixels);

	  } else {
		glDrawPixels(imageinfo.xsize,imageinfo.ysize, GL_RGBA,
		   GL_UNSIGNED_BYTE, imageinfo.pixels);
	  }
	  //printf( "glDrawPixels %d\n",glGetError());

#else
	  glDrawPixels(imageinfo.xsize,imageinfo.ysize, GL_ABGR_EXT,
	   GL_UNSIGNED_BYTE, imageinfo.pixels);
#endif   
	  
	}
  else
    {
      glClearColor(.5,1,.2,1);
      glClear(GL_COLOR_BUFFER_BIT);
    }
}
  
void ImageWin::attachImage(ImageInfo info)
{
  imageinfo=info;
  glutSetWindow(glWindowNum);

  if (info.xsize>0 && info.ysize>0)
    {
      glutShowWindow();
      glutReshapeWindow(info.xsize, info.ysize);
    }
  else
    {
      puts ("hide window in imagewin");
      imageinfo.pixels=NULL;
      glutHideWindow();
    }

  glutPostRedisplay();
}

