#include "glTools.h"
#include <GL/glut.h>
//#include <GL/gl.h>
#include <string.h>
#include <iostream.h>

void gltDrawBox(double left, double top, double right, double bottom)
{
  glBegin(GL_POLYGON);
  glVertex2d(left,top);
  glVertex2d(right,top);
  glVertex2d(right,bottom);
  glVertex2d(left,bottom);
  glEnd();
}

void gltDrawBoxOutline(double left, double top, double right, double bottom)
{
  glBegin(GL_LINES);
  glVertex2d(left,top);
  glVertex2d(right,top);
  glVertex2d(right,bottom);
  glVertex2d(left,bottom);
  glEnd();
}

void gltFadingLine(double startPoint[3], double endPoint[3], int segments)
{
  // Get the current color
  double color[4],modcolor[4];
  glGetDoublev(GL_CURRENT_COLOR,color);
  glGetDoublev(GL_CURRENT_COLOR,modcolor);



  double dir[3];
  dir[0]=(endPoint[0]-startPoint[0])/double(segments);
  dir[1]=(endPoint[1]-startPoint[1])/double(segments);
  dir[2]=(endPoint[2]-startPoint[2])/double(segments);
  
  // Loop over segments drawing the line
  for (int i=0;i<segments;i++)
    {
      double di=i;
      modcolor[3]=(double(segments-i))/segments;
      //modcolor[2]=(double(segments-i))/segments;
      //cout << i << " " << modcolor[2] << endl;
      glColor4dv(modcolor);
      
      glBegin(GL_LINES);
      glVertex3d(startPoint[0]+dir[0]*di,
		 startPoint[1]+dir[1]*di,
		 startPoint[2]+dir[2]*di);
      glVertex3d(startPoint[0]+dir[0]*(di+1),
		 startPoint[1]+dir[1]*(di+1),
		 startPoint[2]+dir[2]*(di+1));
      glEnd();
    }
  
  // Restore original color
  glColor4dv(color);
}
