#include "jed.h"
#include "JDImage.h"
#include "imageil.h"
#include <il/ilMemoryImg.h>
#include <iostream.h>

void jdimage_to_ilImage(ImageInfo im, ilMemoryImg &il)
{
  // Make config parameters
  iflSize sz(im.xsize, im.ysize,1,4);

  // Set the values
  il.setSize(sz);
  il.setDataType(iflUChar);
  il.setOrder(iflInterleaved);
  il.setColorModel(iflABGR);

  COUT << "size " << il.getXsize() << " " << il.getYsize() << endl;
  
  // Copy the tile
  ilStatus sts;
  sts=il.setTile(0,0,im.xsize,im.ysize,im.pixels);
  if (sts != ilOKAY)
    {
      COUT << "Failed to setTile" << endl;
    }
}

void ilImage_to_jdimage(ilImage *il, JDImage &im)
{
  COUT << "size " << il->getXsize() << " " << il->getYsize() << endl;
  
  // Resize the jdimage
  im.resize(il->getXsize(),il->getYsize());

  // Set to be the right data format
  il->setDataType(iflUChar);
  il->setOrder(iflInterleaved);
  il->setColorModel(iflABGR);

  // Copy data
  ilStatus sts;
  sts=il->getTile(0,0,im.xsize,im.ysize,im.pixels);
  if (sts != ilOKAY)
    {
      COUT << "Failed to getTile" << endl;
    }
}
