#include "jed.h"
#include "iflinterface.h"
#include "imageil.h"
#include "CLO.h"
#include <string>
#pragma set woff 1375
#include <il/ilGBlurImg.h>
#include <ifl/iflPixel.h>
#pragma reset woff 1375

main (int argc, char **argv)
{
  // Set up command line options
  CLOchar255 filename("","ffilename","Name of file to read");

  // Parse options
  CLO::parseArgs(argc,argv);
  if (std::string(filename)=="")
    {
      CLO::showusage(argv[0]);
      exit(2);
    }

  
  // Open a test image
  JDImage im;
  readJDImage(CSTR(std::string(filename)),im);

  // Convert it to il format
  ilMemoryImg il;
  ilMemoryImg il2;
  jdimage_to_ilImage(im,il);
  il2.setDataType(iflFloat);
  jdimage_to_ilImage(im,il2);
  
  // Do something in il
  ilGBlurImg ilblur(&il,1.0,30.0,2.0);
  
  // Convert back to my format
  ilImage_to_jdimage(&ilblur,im);
  
  // Save the file
  writeJDImage("output_imageiltest.jpg",im);


  
  // Floating point test
  il2.setDataType(iflFloat);
  ilGBlurImg ilblur2(&il2,1.0,30.0,2.0);
  iflPixel pix;
  ilblur2.getPixel(100,100,pix);
  float fpix= pix[0];
  cout << fpix << endl;

  iflPixel pix1;
  ilblur.getPixel(100,100,pix1);
  double  cpix= pix1[0];
  cout << pix1[0] << " " << pix[1] << " " << pix[2] << endl;

  // Ty printing some values
  
}
