//
// defs.h
//
// $Id: defs.h,v 1.1 2003/05/22 01:13:24 jedavis Exp $
//

#ifndef SGL_DEFS_H
#define SGL_DEFS_H

#ifdef _WIN32
#define COMPILER_HAS_BOOL
#else
#ifdef __linux
#define COMPILER_HAS_BOOL
#else
#ifdef _COMPILER_VERSION
#if (_COMPILER_VERSION >= 621)
#define COMPILER_HAS_BOOL
#endif
#endif
#endif
#endif

#ifndef COMPILER_HAS_BOOL
#define bool int
#define true 1
#define false 0
#endif /* !COMPILER_HAS_BOOL */

#include <stdlib.h>
#include <iostream>
#include <assert.h>

// typedefs

typedef unsigned int u_int;
typedef unsigned short int us_int;
typedef unsigned char u_char;
typedef unsigned long u_long;

// defs missing from Win32 math.h

#ifdef _WIN32
#define M_E             2.7182818284590452354
#define M_LOG2E         1.4426950408889634074
#define M_LOG10E        0.43429448190325182765
#define M_LN2           0.69314718055994530942
#define M_LN10          2.30258509299404568402
#define M_PI            3.14159265358979323846
#define M_PI_2          1.57079632679489661923
#define M_PI_4          0.78539816339744830962
#define M_1_PI          0.31830988618379067154
#define M_2_PI          0.63661977236758134308
#define M_2_SQRTPI      1.12837916709551257390
#define M_SQRT2         1.41421356237309504880
#define M_SQRT1_2       0.70710678118654752440
#endif

#endif // SGL_DEFS_H
