#include "JDImage.h"
#include "JDMovie.h"
#include <stdio.h>
#include <stdlib.h>
#include "auxWindow.h"
#include <GL/gl.h>

main(int argc, char **argv)
{
  if(argc<2)
    {
      puts ("usage: movieplay <filename>");
      exit(2);
    }

  // Open a movie
  MVid movie;
  movieOpen(argv[1], movie);

  short xsize ,ysize ;

  // Get the movie xy size
  movieXYSize(movie, xsize ,ysize);

  // open a window
  auxMakeWindow(xsize,ysize,1);

  // find the number of frames
  short movieLength=movieNumFrames(movie);

  // allocate some storage space
  JDImage frame(xsize, ysize);

  // get and draw each frame
  for (int i=0; i< movieLength; i++)
    {
      movieGetFrame(movie,i, frame);
      glDrawPixels(xsize,ysize,  GL_ABGR_EXT, GL_UNSIGNED_BYTE, frame.pixels);
    }
}
