#ifndef VID_H
#define VID_H

#include <dmedia/vl.h>

typedef struct 
{
  VLServer svr;
  VLPath path;
  VLNode src;
  VLNode drn;
  VLBuffer buffer;
  
} VidInfo;

VidInfo *vidInit();
void     vidQuit(VidInfo *info);
char    *vidIn(VidInfo *info, int *sequence=NULL);
char    *vidInLatest(VidInfo *info, int *sequence=NULL);
void     vidGetXYSize(VidInfo *info, long *x, long *y);
void     vidSetXYSize(VidInfo *info, int x, int y);
void     vidDeleteBuffer(VidInfo *info);
void     vidCreateBuffer(VidInfo *info);
void vidSetZoom(VidInfo *info, int num, int den);
void vidSetCapType(VidInfo *info, int captype);
void vidSetRate(VidInfo *info, int rate);
void vidSetPacking(VidInfo *info, int packing);

/* Note that this expires all these buffers while obtaining the count */
int  vidBuffersPending(VidInfo *info);



#endif 

