
#include "vidInterfaceVisionSDK.h"

#include <iostream.h>



int main(int argc, const char *argv[])
{
	// Check for filename argument
    if ( argc < 3 ) {
		fprintf(stderr,"Usage: %s: input.avi output.avi\n",argv[0]);
		return -1;
	}

	// Open the movie file in question
	MVid movieIn;
	movieOpen(argv[1],movieIn);

	// Create an output movie file 
	MVid movieOut;
	movieCreate(argv[2],movieOut);

	// Get some storage for a frame
	JDImage thisFrame;

	// Loop over all movie frames
	for (int i=0;i<movieNumFrames(movieIn);i++) {
	
		// Read from the input movie
		movieGetFrame(movieIn, movieNumFrames(movieIn)-i-1, thisFrame);

		// Write to the output movie
		moviePutFrame(movieOut, i, thisFrame);

		// Diagnostic
		printf("In: %d   Out: %d \n", movieNumFrames(movieIn)-i-1, i);
	}

	// Close the movies
	movieClose(movieIn);
	movieClose(movieOut);

    return 0;
}


