
#ifndef VIDINTERFACE_H
#define VIDINTERFACE_H

#include <VisSDK/inc/VisCore.h>
#include "JDImage.h"



// Structure for storing info about open movies
enum MovieStatus {none, read, write};
class MVid {
public:
	CVisStreamHandler* pStrmHandler; // Used for writing
	CVisRGBAByteSequence seq; // Used for reading
	MovieStatus status; // Open for reading/writing/nothing

	MVid():status(none),pStrmHandler(NULL){}
};

// open for reading - close
void movieOpen(const char *filename, MVid &movie);
void movieClose(MVid &movie);

// Create movie for writing, last two arguments ignored, first frame sets size
void movieCreate(const char *filename, MVid &movie, short xsize=0, short ysize=0);
void movieCreateWithCompressDialog(const char *filename, MVid &movie, short xsize=0, short ysize=0);

// Get and put in the VisionSDK format
void moviePutFrameCV(MVid &movie, short framenum, CVisRGBAByteImage &frame);
void movieGetFrameCV(MVid &movie, short framenum, CVisRGBAByteImage &frame);

// Convert back and forth between VisionSDK and JDImage
void CVisRGBA_to_JDImage(CVisRGBAByteImage &in, JDImage &out);
void JDImage_to_CVisRGBA(JDImage &in, CVisRGBAByteImage &out);

// Put/Get frames in JDImage format
void moviePutFrame(MVid &movie, short framenum, JDImage &framejd);
void movieGetFrame(MVid &movie, short framenum, JDImage &frame);

// How many frames in a movie file
short movieNumFrames(MVid &movie);

// What size is a frame
void movieXYSize(MVid &movie, short &x, short &y);


#endif