#ifndef OWNERIMAGEWINDOW_H
#define OWNERIMAGEWINDOW_H

#include "imagewindow.h"
#include "buffer.h"

template <class T> class OwnerImageWindow: public ImageWindow<T> {
    public:
        OwnerImageWindow() 
        { ImageWindow<T>::SetBuffer(&buffer); }
        virtual ~OwnerImageWindow() 
        { ; }
        int Load(const Buffer<T> &other)
        {
            if (!buffer.Load(other)) {
                errorf(("Error loading from other buffer"));
                return 0;
            }
            return Fit();
        }
        Buffer<T> &GetBuffer(void) { return buffer; }
        const Buffer<T> &GetBuffer(void) const { return buffer; }
    private:
        Buffer<T> buffer;
};

typedef OwnerImageWindow<Uchar> OwnerImageWindowUchar;
typedef OwnerImageWindow<Ushort> OwnerImageWindowUshort;
typedef OwnerImageWindow<Ulong> OwnerImageWindowUlong;
typedef OwnerImageWindow<float> OwnerImageWindowFloat;
typedef OwnerImageWindow<double> OwnerImageWindowDouble;

#endif // OWNERIMAGEWINDOW_H
