#ifndef PLOTWINDOW_H
#define PLOTWINDOW_H

#include "window.h"
#include "poly.h"

class PlotWindow2: public Window {
    public:
        PlotWindow2();
        int SetData(const Poly2 &data, int set = 0);
        int SetData(const double *data, int count, int set = 0);
        int SetData(const float *data, int count, int set = 0);
        Poly2 &GetData(int set = 0);
        int SetBBox(const BBox2 &box, int set = 0);
        virtual void Display(void);
        void Empty(void);
    private:
        class Plot {
            public:
                Poly2 data;
                BBox2 box;
        };
        void Color(int set);
        void DrawData(void);
        void DrawFrame(void);
        Array<Plot> plot;
};

#endif
