#ifndef POLYGON_H_
#define POLYGON_H_

#include "bbox.h"
#include "array.h"

template <int N> class Poly: public Array< Vector<N> > { 
    public:
        BBox<N> GetBBox(void) const
        {
            BBox<N> t;
            for (int i = 0; i < GetSize(); i++) {
                t.Merge((*this)[i]);
            }
            return t;
        }
};

typedef Poly<2> Poly2;
typedef Poly<3> Poly3;

#endif
