#ifndef SOUPWINDOW_H
#define SOUPWINDOW_H

#include "window.h"
#include "soup.h"
#include "arcball.h"
#include "trans.h"
#include "zoom.h"
#include "bbox.h"
#include "vector.h"

class SoupWindow: public Window {
    public:
        SoupWindow();
        virtual ~SoupWindow();
        void SetSoup(Soup *soup);
        Soup *GetSoup(void);
        int Fit(void);
        virtual void Init(int id);
        virtual void Display(void);
        virtual void Button(int button, int state, int x, int y); 
        virtual void Motion(int x, int y); 
        virtual void Reshape(int w, int h, int x0, int y0);
        virtual void Keyboard(unsigned char c, int x, int y);
        void SetLightPosition(float *p);
    private:
        typedef enum { MODE_TRIANGLES, MODE_POINTS } e_mode;
        float light[4];
        void DrawSoup(void);
        Soup *soup;
        Vector3 center;
        double size;
        e_mode mode;
        Arcball ball;
        Zoom zoom;
        Trans trans;
        int list;
};

#endif // SOUPWINDOW_H
