
#include "vidInterfaceVisionSDK.h"

#include "ImageWin.h"
#include <iostream.h>
#include "glutTools.h"
#include "pngtarmovie.h"
#include "jed.h"
#include <vector>
#include "jd_time.h"

bool gUsingTarMovie=false;

class MovieWin : ImageWin {
public:
	std::vector <JDImage *> imgvec;
	MVid movie;
	PngTarMovie omovie;
	
	MovieWin() {
	}

	// This idle() routine gets run every 200ms
	// displaying the image is handled by the routine in ImageWin
	/*void idle() {

		// Increment the current frame number
		curFrameNum = (curFrameNum+1)%movieNumFrames(movie);

		// Get the correct frame from the movie file
		movieGetFrame(movie, curFrameNum, curFrame);

		// Make this the current image for ImageWin->display();
		attachImage(curFrame);

		// Print a diagnostic
		printf ("Showing frame: %d\n",curFrameNum);
	}*/

	int movieNumFrames(MVid &movie) {
		if (gUsingTarMovie) {
			return omovie.GetLength();
		} else {
			return ::movieNumFrames(movie);
		}
	}


	void loadAllFrames()
	{
		int numFrames=movieNumFrames(movie);

		for (int i=0;i<numFrames;i++) {

			int curFrameNum=i;
			JDImage *jdim=new JDImage;
			JDImage &curFrame= *jdim;

			// Get the correct frame from the movie file
			if (gUsingTarMovie) {
				BufferUchar ibuf;
				
				if (omovie.Read(curFrameNum,ibuf)) {
					ibuf.Flip();
					curFrame.resize(ibuf.GetWidth(), ibuf.GetHeight());
					ibuf.Store(((unsigned char *)curFrame.pixels)+0,4,0,0);
					ibuf.Store(((unsigned char *)curFrame.pixels)+1,4,0,1);
					ibuf.Store(((unsigned char *)curFrame.pixels)+2,4,0,2);
				} else {
					COUT << "Error reading frame " << curFrameNum << endl;
					return;
				}
				
			} else {
				movieGetFrame(movie, curFrameNum, curFrame);
			}
			
			imgvec.push_back(jdim);
			
			// Print a diagnostic
			printf ("Loading frame: %d\n",i);
			
		}
		
	}




	

	void display() {

		static bool firsttime=true;
		static unsigned long lasttime=0;

		if (firsttime) {
			loadAllFrames();
			attachImage(*imgvec[0]);
			firsttime=false;
			return;
		}

		int curIm=0;
		int numFrames=imgvec.size();

		while (1) {
			// attach the image
			//attachImage(*imgvec[curIm]);
			imageinfo= (*imgvec[curIm]);

			// Show the image
			ImageWin::display();
			//glFinish();

			unsigned long curtime=Get_Milliseconds();

			// Text overlay
			///*
			char buf[120];
			sprintf(buf,"Frame Number %d %d",curtime-lasttime,curIm);
			glutSetStringPos(20,20);
			glutBitmapString(buf);
			glFlush();
			//*/

			glutSwapBuffers();

			lasttime=curtime;

			// Increment the current frame
			curIm=(curIm+1)%numFrames;
		}

		
		
	} 
	

	
};


int main(int argc, const char *argv[])
{
	// Check for filename argument
    if ( argc < 2 ) {
		fprintf(stderr,"Usage %s: input.avi\n",argv[0]);
		return -1;
	}

		// Turn on 1ms accuracy in win2k
	SetTrueMillisecondAccuracy();


	glutInitDisplayMode(GLUT_DOUBLE);

	// Create a window that knows how to play movies
	MovieWin mwin;

	if (!strcmp(argv[1]+strlen(argv[1])-3,"tar")) {
		gUsingTarMovie=true;
	}

	// Open the movie file in question
	if (gUsingTarMovie) {
		// Open tar movie
		if (!mwin.omovie.Load(argv[1])) {
			COUT << "Error" << endl;
			return -2;
		}

	} else {
		// Open avi movie
		movieOpen(argv[1],mwin.movie);
	}
	

	// Enter the glut main loop, which falls through to idle() above
	glutMainLoop();

    return 0;
}


